# API Docs - v1.1.0

## Env

### getEnvironmentProperty *<a target="_blank" href="https://wso2.github.io/siddhi/documentation/siddhi-4.0/#function">(Function)</a>*

<p style="word-wrap: break-word">This function returns the Java environment property that corresponds with the key provided</p>

<span id="syntax" class="md-typeset" style="display: block; font-weight: bold;">Syntax</span>
```
<STRING> env:getEnvironmentProperty(<STRING> key, <STRING> default.value)
```

<span id="query-parameters" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">QUERY PARAMETERS</span>
<table>
    <tr>
        <th>Name</th>
        <th style="min-width: 20em">Description</th>
        <th>Default Value</th>
        <th>Possible Data Types</th>
        <th>Optional</th>
        <th>Dynamic</th>
    </tr>
    <tr>
        <td style="vertical-align: top">key</td>
        <td style="vertical-align: top; word-wrap: break-word">This specifies the key of the property to be read.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
    <tr>
        <td style="vertical-align: top">default.value</td>
        <td style="vertical-align: top; word-wrap: break-word">This specifies the default value to be returned if the property value is not available.</td>
        <td style="vertical-align: top">null</td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">Yes</td>
        <td style="vertical-align: top">No</td>
    </tr>
</table>

<span id="examples" class="md-typeset" style="display: block; font-weight: bold;">Examples</span>
<span id="example-1" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">EXAMPLE 1</span>
```
define stream keyStream (key string);
from keyStream env:getEnvironmentProperty(key) as FunctionOutput 
insert into outputStream;
```
<p style="word-wrap: break-word">This query returns the Java environment property that corresponds with the key from the 'keyStream' as 'FunctionOutput' to the outputStream.</p>

### getOriginIPFromXForwarded *<a target="_blank" href="https://wso2.github.io/siddhi/documentation/siddhi-4.0/#function">(Function)</a>*

<p style="word-wrap: break-word">This function returns the public origin IP from the given X-Forwarded header.</p>

<span id="syntax" class="md-typeset" style="display: block; font-weight: bold;">Syntax</span>
```
<STRING> env:getOriginIPFromXForwarded(<STRING> xforwardedheader)
```

<span id="query-parameters" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">QUERY PARAMETERS</span>
<table>
    <tr>
        <th>Name</th>
        <th style="min-width: 20em">Description</th>
        <th>Default Value</th>
        <th>Possible Data Types</th>
        <th>Optional</th>
        <th>Dynamic</th>
    </tr>
    <tr>
        <td style="vertical-align: top">xforwardedheader</td>
        <td style="vertical-align: top; word-wrap: break-word">The 'X-Forwarded-For' header of the request.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
</table>

<span id="examples" class="md-typeset" style="display: block; font-weight: bold;">Examples</span>
<span id="example-1" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">EXAMPLE 1</span>
```
define stream InputStream (xForwardedHeader string);
from InputStream select env:getOriginIPFromXForwarded(xForwardedHeader) as originIP 
insert into OutputStream;
```
<p style="word-wrap: break-word">This query returns the public origin IP from the given X-Forwarded header as 'originIP', and inserts it to the 'OutputStream' stream.</p>

### getSystemProperty *<a target="_blank" href="https://wso2.github.io/siddhi/documentation/siddhi-4.0/#function">(Function)</a>*

<p style="word-wrap: break-word">This function returns the system property referred to via the system property key.</p>

<span id="syntax" class="md-typeset" style="display: block; font-weight: bold;">Syntax</span>
```
<STRING> env:getSystemProperty(<STRING> key, <STRING> default.value)
```

<span id="query-parameters" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">QUERY PARAMETERS</span>
<table>
    <tr>
        <th>Name</th>
        <th style="min-width: 20em">Description</th>
        <th>Default Value</th>
        <th>Possible Data Types</th>
        <th>Optional</th>
        <th>Dynamic</th>
    </tr>
    <tr>
        <td style="vertical-align: top">key</td>
        <td style="vertical-align: top; word-wrap: break-word">This specifies the key of the property to be read.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
    <tr>
        <td style="vertical-align: top">default.value</td>
        <td style="vertical-align: top; word-wrap: break-word">This specifies the default value to be returned if the property value is not available.</td>
        <td style="vertical-align: top">null</td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">Yes</td>
        <td style="vertical-align: top">No</td>
    </tr>
</table>

<span id="examples" class="md-typeset" style="display: block; font-weight: bold;">Examples</span>
<span id="example-1" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">EXAMPLE 1</span>
```
define stream KeyStream (key string);
from KeyStream env:getSystemProperty(key) as FunctionOutput 
insert into OutputStream;
```
<p style="word-wrap: break-word">This query returns the system property that corresponds with the key from the 'KeyStream' stream as the 'FunctionOutput' to the 'OutputStream' stream.</p>

### getUserAgentProperty *<a target="_blank" href="https://wso2.github.io/siddhi/documentation/siddhi-4.0/#function">(Function)</a>*

<p style="word-wrap: break-word">This function returns the value that corresponds with a specified property name of a specified user agent</p>

<span id="syntax" class="md-typeset" style="display: block; font-weight: bold;">Syntax</span>
```
<STRING> env:getUserAgentProperty(<STRING> user.agent, <STRING> property.name)
```

<span id="query-parameters" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">QUERY PARAMETERS</span>
<table>
    <tr>
        <th>Name</th>
        <th style="min-width: 20em">Description</th>
        <th>Default Value</th>
        <th>Possible Data Types</th>
        <th>Optional</th>
        <th>Dynamic</th>
    </tr>
    <tr>
        <td style="vertical-align: top">user.agent</td>
        <td style="vertical-align: top; word-wrap: break-word">This specifies the user agent from which the property needs to be extracted.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
    <tr>
        <td style="vertical-align: top">property.name</td>
        <td style="vertical-align: top; word-wrap: break-word">This specifies the property name that needs to be extracted. Supported property names are 'browser', 'os', and 'device'.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
</table>

<span id="system-parameters" class="md-typeset" style="display: block; font-weight: bold;">System Parameters</span>
<table>
    <tr>
        <th>Name</th>
        <th style="min-width: 20em">Description</th>
        <th>Default Value</th>
        <th>Possible Parameters</th>
    </tr>
    <tr>
        <td style="vertical-align: top">regexFilePath</td>
        <td style="vertical-align: top; word-wrap: break-word">The location of the yaml file that contains the regex to process the user agent.</td>
        <td style="vertical-align: top">Default regexes included in the ua_parser library</td>
        <td style="vertical-align: top">N/A</td>
    </tr>
</table>

<span id="examples" class="md-typeset" style="display: block; font-weight: bold;">Examples</span>
<span id="example-1" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">EXAMPLE 1</span>
```
define stream UserAgentStream (userAgent string);
from UserAgentStream 
select env:getUserAgentProperty(userAgent, "browser") as functionOutput 
insert into OutputStream;
```
<p style="word-wrap: break-word">This query returns the browser name of the 'userAgent' from the 'UserAgentStream' stream as 'functionOutput', and inserts it into the 'OutputStream'stream.</p>

### getYAMLProperty *<a target="_blank" href="https://wso2.github.io/siddhi/documentation/siddhi-4.0/#function">(Function)</a>*

<p style="word-wrap: break-word">This function returns the YAML property requested or the default values specified if such avariable is not specified in the 'deployment.yaml'.</p>

<span id="syntax" class="md-typeset" style="display: block; font-weight: bold;">Syntax</span>
```
<INT|LONG|DOUBLE|FLOAT|STRING|BOOL> env:getYAMLProperty(<STRING> key, <STRING> data.type, <INT|LONG|DOUBLE|FLOAT|STRING|BOOL> default.value)
```

<span id="query-parameters" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">QUERY PARAMETERS</span>
<table>
    <tr>
        <th>Name</th>
        <th style="min-width: 20em">Description</th>
        <th>Default Value</th>
        <th>Possible Data Types</th>
        <th>Optional</th>
        <th>Dynamic</th>
    </tr>
    <tr>
        <td style="vertical-align: top">key</td>
        <td style="vertical-align: top; word-wrap: break-word">This specifies key of the property to be read.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
    <tr>
        <td style="vertical-align: top">data.type</td>
        <td style="vertical-align: top; word-wrap: break-word">A string constant parameter expressing the data type of the propertyusing one of the following string values:<br>&nbsp;int, long, float, double, string, bool.</td>
        <td style="vertical-align: top">string</td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
    <tr>
        <td style="vertical-align: top">default.value</td>
        <td style="vertical-align: top; word-wrap: break-word">This specifies the default value to be returned if the property value is not available.</td>
        <td style="vertical-align: top">null</td>
        <td style="vertical-align: top">INT<br>LONG<br>DOUBLE<br>FLOAT<br>STRING<br>BOOL</td>
        <td style="vertical-align: top">Yes</td>
        <td style="vertical-align: top">No</td>
    </tr>
</table>

<span id="examples" class="md-typeset" style="display: block; font-weight: bold;">Examples</span>
<span id="example-1" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">EXAMPLE 1</span>
```
define stream KeyStream (key string);
from KeyStream  env:getYAMLProperty(key) as FunctionOutput 
insert into outputStream;
```
<p style="word-wrap: break-word">This query returns the corresponding YAML property for the corresponding key from the 'KeyStream' stream as 'FunctionOutput', and inserts it into the to the 'OutputStream' stream.</p>

### resourceIdentifier *<a target="_blank" href="https://wso2.github.io/siddhi/documentation/siddhi-4.0/#stream-processor">(Stream Processor)</a>*

<p style="word-wrap: break-word">The resource identifier stream processor is an extension to register a resource name with a reference in a static map and serve a static resources count for a specific resource name.</p>

<span id="syntax" class="md-typeset" style="display: block; font-weight: bold;">Syntax</span>
```
env:resourceIdentifier(<STRING> resource.group.id)
```

<span id="query-parameters" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">QUERY PARAMETERS</span>
<table>
    <tr>
        <th>Name</th>
        <th style="min-width: 20em">Description</th>
        <th>Default Value</th>
        <th>Possible Data Types</th>
        <th>Optional</th>
        <th>Dynamic</th>
    </tr>
    <tr>
        <td style="vertical-align: top">resource.group.id</td>
        <td style="vertical-align: top; word-wrap: break-word">The name of the resource group.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
</table>

<span id="examples" class="md-typeset" style="display: block; font-weight: bold;">Examples</span>
<span id="example-1" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">EXAMPLE 1</span>
```
@info(name='product_color_code_rule') 
from SweetProductDefectsDetector#env:resourceIdentifier("rule-group-1")
select productId, ifThenElse(colorCode == '#FF0000', true, false) as isValid
insert into DefectDetectionResult;

@info(name='product_dimensions_rule') 
from SweetProductDefectsDetector#env:resourceIdentifier("rule-group-1")
select productId, ifThenElse(height == 5 && width ==10, true, false) as isValid
insert into DefectDetectionResult;
@info(name='defect_analyzer') 
from DefectDetectionResult#window.env:resourceBatch("rule-group-1", productId, 60000)
select productId, and(not isValid) as isDefected
insert into SweetProductDefectAlert;
```
<p style="word-wrap: break-word">'product_color_code_rule' and 'product_dimensions_rule' are two rule-based queries that process the same events from the 'SweetProductDefectsDetector' stream. They both insert their process results as the output into the 'DefectDetectionResult' output stream.<br><br>Multiple queries like this can be added in the Siddhi Application and the number of output events inserted into the 'DefectDetectionResult' stream depends on the number of available queries. If you need to further aggregate results for a particular correlation ID ('productId' in this scenario) from the 'DefectDetectionResult' stream, follow-up queries need to wait for events with same value for the 'productId' attribute from all the available queries. For this, follow-up queries need to identify the number of events that can be expected from these rule-based queries with a specific value for 'productID'. To address this requirement, a resource identifier named 'rule-group-1' is assigned to both the rule queries. The 'defect_analyzer' query includes the 'env:resourceBatch' window to derive the count for the registered resource named 'rule-group-1' count from the output of both the queries within a specific time period. All of these factors determine the event waiting condition for events from the 'DefectDetectionResult' stream.</p>

### resourceBatch *<a target="_blank" href="https://wso2.github.io/siddhi/documentation/siddhi-4.0/#window">(Window)</a>*

<p style="word-wrap: break-word">This extension is a resource batch (tumbling) window that holds a number of events based on the resource count inferred from the 'env:resourceIdentifier' extension, and with a specific attribute as the grouping key. The window is updated each time a batch of events arrive with a matching value for the grouping key, and where the number of events is equal to the resource count.</p>

<span id="syntax" class="md-typeset" style="display: block; font-weight: bold;">Syntax</span>
```
env:resourceBatch(<STRING> resource.group.id, <INT|LONG|FLOAT|BOOL|DOUBLE> correlation.id, <INT|LONG|TIME> time.in.milliseconds)
```

<span id="query-parameters" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">QUERY PARAMETERS</span>
<table>
    <tr>
        <th>Name</th>
        <th style="min-width: 20em">Description</th>
        <th>Default Value</th>
        <th>Possible Data Types</th>
        <th>Optional</th>
        <th>Dynamic</th>
    </tr>
    <tr>
        <td style="vertical-align: top">resource.group.id</td>
        <td style="vertical-align: top; word-wrap: break-word">The name of the resource group.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">STRING</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
    <tr>
        <td style="vertical-align: top">correlation.id</td>
        <td style="vertical-align: top; word-wrap: break-word">The attribute that should be used for event correlation.</td>
        <td style="vertical-align: top"></td>
        <td style="vertical-align: top">INT<br>LONG<br>FLOAT<br>BOOL<br>DOUBLE</td>
        <td style="vertical-align: top">No</td>
        <td style="vertical-align: top">No</td>
    </tr>
    <tr>
        <td style="vertical-align: top">time.in.milliseconds</td>
        <td style="vertical-align: top; word-wrap: break-word">The time period to wait for the arrival of a new event before generating the output for events belonging to a specific batch and flushing them.</td>
        <td style="vertical-align: top">300000</td>
        <td style="vertical-align: top">INT<br>LONG<br>TIME</td>
        <td style="vertical-align: top">Yes</td>
        <td style="vertical-align: top">No</td>
    </tr>
</table>

<span id="examples" class="md-typeset" style="display: block; font-weight: bold;">Examples</span>
<span id="example-1" class="md-typeset" style="display: block; color: rgba(0, 0, 0, 0.54); font-size: 12.8px; font-weight: bold;">EXAMPLE 1</span>
```
define stream SweetProductDefectsDetector(productId string, colorCode string, height long, width long);
define stream SweetProductDefectAlert(productId string, isDefected bool);

@info(name='product_color_code_rule') 
from SweetProductDefectsDetector#env:resourceIdentifier("rule-group-1")
select productId, ifThenElse(colorCode == '#FF0000', true, false) as isValid
insert into DefectDetectionResult;

@info(name='product_dimensions_rule') 
from SweetProductDefectsDetector#env:resourceIdentifier("rule-group-1")
select productId, ifThenElse(height == 5 && width ==10, true, false) as isValid
insert into DefectDetectionResult;

@info(name='defect_analyzer') 
from DefectDetectionResult#window.env:resourceBatch("rule-group-1", productId, 60000)
select productId, and(not isValid) as isDefected
insert into SweetProductDefectAlert;
```
<p style="word-wrap: break-word">This example demonstrates the usage of the 'env:resourceBatch' widow extension with the 'env:resourceIdentifier' stream processor and the 'and' attribute aggregator extension.<br><br>Data relating to the sweet production is received into the 'SweetProductDefectsDetector' input stream. This data is consumed by two rule queries named 'product_color_code_rule' and 'product_dimensions_rule'.<br><br>The follow-up query named 'defect_analyzer' needs to wait for the output results of both the rule queries mentioned above, and generate an output based on aggregated results.<br><br>To ensure that each event from the 'SweetProductDefectsDetector' input stream is processed by both the rule queries, they are grouped together. This is done by assigning a resource identifier named 'rule-group-1' to each rule query.<br><br>The 'defect_analyzer' follow-up query waits until an equal number of output events with the same value for the 'productID' attribute are generated by both the rule queries for the 'rule-group-1' resource identifier. Then it selects the events where  the product ID is matching and the value for the 'isValid' attribute is not 'true'.<br><br>When deriving this output, a 'resourceBatch' time window of 2000 milliseconds is considered. This checks whether events that match the criteria outlined above occurs within a time period of 2000 milliseconds in a tumbling manner. If the criteria is not met within 2000 events, the events within that time window are considered expired and flushed from the window. If the criteria is met within the time window of 2000 milliseconds, the output is inserted into the "SweetProductDefectAlert' output stream as boolean values where 'isDefected' attribute is set to 'true'. The sample output can be as given below.<br><br>Input 1: [SweetProductDefectsDetector]<br>{  <br>&nbsp;&nbsp;&nbsp;"event":{  <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"productId":"Cake",<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"colorCode":"FF0000",<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"height": 5,<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"width": 10<br><br>&nbsp;&nbsp;&nbsp;}<br>}<br><br>Output 1:[SweetProductDefectAlert]<br>{  <br>&nbsp;&nbsp;&nbsp;"event":{  <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"productId":"Cake",<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"isDefected":"false"<br>&nbsp;&nbsp;&nbsp;}<br>}<br><br>Input 2: [SweetProductDefectsDetector]<br>{  <br>&nbsp;&nbsp;&nbsp;"event":{  <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"productId":"Cake",<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"colorCode":"FF0000",<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"height": 10,<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"width": 20<br><br>&nbsp;&nbsp;&nbsp;}<br>}<br><br>Output 2:[SweetProductDefectAlert]<br>{  <br>&nbsp;&nbsp;&nbsp;"event":{  <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"productId":"Cake",<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"isDefected":"true"<br>&nbsp;&nbsp;&nbsp;}<br>}</p>

